/* public domain. dtb. 2024. */// :3 <3 -3

#include <stdint.h>
#include "lstring.h"

/* Returns the address immediately following the current lstr. */
#define RETEXP(type) \
	&((uint8_t *)(current))[sizeof type + sizeof char * current->len - 1]
/*                          |~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *                          | This is the size (in bytes) of the lstr8,
 *                          | ASSUMING the string contents are stored as part
 *                          | of the struct (i.e. str == &len[1]). */
 lstr8  *lstr8_next( lstr8 *current){ return RETEXP( lstr8); }
lstr16 *lstr16_next(lstr16 *current){ return RETEXP(lstr16); }
lstr32 *lstr32_next(lstr32 *current){ return RETEXP(lstr32); }
lstr64 *lstr64_next(lstr64 *current){ return RETEXP(lstr64); }
#undef RETEXP
